import { defaultPackage } from '../../../.majora.js';
const { components, currentBuild } = require('../../../.majora.lock.json');

export default function({ types: t }) {
  const isWhiteLabel = currentBuild !== defaultPackage;

  return {
    name: "babel-codemod-majorajs", // not required
    visitor: {
      ImportDeclaration(path, state) {
        const isAlreadySwapped = path.node.source.value.includes('.whitelabel');

        if (!isWhiteLabel || isAlreadySwapped) {
          return;
        }

        if (!path.node.specifiers.length) {
          return;
        }

        const { name } = path.node.specifiers[0].local;

        const isIdentifierInList = !!components.find(({ identifier }) => identifier === name);

        if (isIdentifierInList) {
          path.replaceWith(
            t.importDeclaration(
              [t.importDefaultSpecifier(t.identifier(path.node.specifiers[0].local.name))],
              t.stringLiteral(path.node.source.value + ".whitelabel")
            )
          );
        }
      }
    }
  };
}
